import { WsApiRequest, WsApiResponse, WsApiRoute } from '../types';
type WsApiConnection<Request extends WsApiRequest> = {
    disconnect: () => void;
    sendRequest: (request: Request) => void;
};
export type WsApiOptions<Request extends WsApiRequest, Response extends WsApiResponse> = {
    onConnected?: (connection: WsApiConnection<Request>) => void;
    onResponse?: (response: Response, connection: WsApiConnection<Request>) => void;
    onError?: (error: unknown, connection: WsApiConnection<Request>) => void;
    onDisconnected?: () => void;
};
export declare const useWsApi: <Action extends string, Request_1 extends object, Response_1 extends object>(wsApiUrl: string, route: WsApiRoute<Action, Request_1, Response_1> | undefined) => {
    connect: (options: WsApiOptions<Request_1, Response_1>) => Promise<void>;
    connected: boolean;
    connection: WsApiConnection<Request_1>;
    error: boolean;
    disconnect: () => void | undefined;
};
export {};
//# sourceMappingURL=useWsApi.d.ts.map